import random, tkFileDialog, tkSimpleDialog, Tkinter, tkMessageBox

######################################################
#
# Randomize MDD_Pointer
# By Jennifer Hachigian 2008
#
# MDD Pointer Node handling added by Ken Nign
#
######################################################


######################################################
#
# QUERY USER FOR INPUT PATH, OUTPUT PATH AND OFFSET
#
######################################################

LWS = tkFileDialog.askopenfilename(title="Choose which MDD_Pointer scene to randomize.", defaultextension=".lws", filetypes=[("LWS files", "*.lws"), ("All files", "*")])

prefix = LWS.rsplit("/", 1)[1][:-4]
iDir = LWS.rsplit("/", 1)[0]

outputPath = tkFileDialog.asksaveasfilename(title="Choose where to write the randomized version.", initialdir=iDir, initialfile="%s_randomized" % prefix, defaultextension=".lws", filetypes=[("LWS files", "*.lws"), ("All files", "*")])

startRange = tkSimpleDialog.askfloat(title="Maximum offset?", initialvalue="1.0", prompt="Choose the maximum offset\n(in seconds)")


######################################################
#
# MAIN PROGRAM
#
######################################################


				
text = open(LWS).read()

newtext = []

lines = text.split("\n")
counter = 0
length = len(lines)

while 1:
	line = lines[counter]
	
	newtext.append(line)
	counter = counter + 1
	
	if line.startswith("Plugin DisplacementHandler") and line.endswith("MDD_Pointer"):
		newtext.append(lines[counter])
		counter = counter + 1
		
		#
		# RANDOMIZE START FRAME
		#
		original = lines[counter]
		newVal = float(original) - (random.random()*startRange)
		newVal = str(newVal)
		newtext.append(newVal)
		counter = counter + 1
		
		for x in xrange(0, 4):
			newtext.append(lines[counter])
			counter = counter + 1

	elif line.endswith("Server \"DP_MDDNode\""):
		#
		# This one will handle the MDD Pointer Node
		#
		for x in xrange(0, 6):
			newtext.append(lines[counter])
			counter = counter + 1
			
		newtext.append(lines[counter])
		counter = counter + 1
		
		#
		# RANDOMIZE START FRAME
		#
		original = lines[counter]
		newVal = float(original) - (random.random()*startRange)
		newVal = str(newVal)
		newtext.append(original.replace(original.lstrip(), newVal))
		counter = counter + 1
		
		for x in xrange(0, 4):
			newtext.append(lines[counter])
			counter = counter + 1
			
	if counter >= length:
		break
		
output = "\n".join(newtext)
		
f1 = open(outputPath, "w")
f1.write(output)
f1.close()

print "Done."
tkMessageBox.showinfo(title="File written successfully.", message="Randomized version written successfully.")
